#include "Point.h"
#include <math.h>



Point::Point()
{
  x = 0;
  y = 0;
}

Point::Point(double a, double b)
{
	x = a;
	y = b;
}

Point operator + (Point &a, Point &b)
{
  Point c;
  c.x = a.x + b.x;
  c.y = a.y + b.y;
  return c;
}
  
  
Point operator - (Point &a, Point &b)
{
  Point c;
  c.x = a.x - b.x;
  c.y = a.y - b.y;
  return c;
}
Point operator * (const double &a, Point &b)
{
	Point c;
	c.x = b.x*a;
	c.y = b.y*a;
	return c;
}
Point operator * (Point &b, const double &a)
{
	Point c;
	c.x = b.x*a;
	c.y = b.y*a;
	return c;
}
double Point::Length()
{
	return sqrt(x*x + y*y);
}
double Point::Dot(Point b)
{
	return x*b.x + y*b.y;
}
void Point::Norm()
{
	double l = Length();
	x = x/l;
	y = y/l;
}
double Point::Ang(Point b)
{
	double t = Dot(b)/(Length()*b.Length());
	double a = acos(t);
	if (a < 0)
		a += 3.14159265358979323;
	return acos(t);
}
double Point::Ang()
{
	double a = atan(y/x);
	if (x < 0 && y < 0)
		a -= 3.14159265358979323;
	if (x < 0 && y > 0)
		a += 3.14159265358979323;
	if (a < 0)
		a += 2*3.14159265358979323;
	return a;
}
void Point::Rot(double a)
{
	double nx, ny;
	nx = x*cos(a) - y*sin(a);
	ny = x*sin(a) + y*cos(a);	
	x = nx;
	y = ny;
}
